import mysql.connector
from sklearn.feature_extraction.text import CountVectorizer
from sklearn.metrics.pairwise import cosine_similarity
import sys
#  # Import the dotenv module
# from dotenv import load_dotenv

#     # Load environment variables from the .env file
# load_dotenv()

# dbhost = os.getenv("dbhost")
# dbuser = os.getenv("dbuser")
# dbpassword = os.getenv("dbpassword")
# dbname = os.getenv("dbname")
# print(dbhost)

mydb = mysql.connector.connect(
host="localhost",
user="root",
password="root",
database="27-11-23"
)

joborder_id = sys.argv[1]

mycursor = mydb.cursor()

mycursor.execute("SELECT c.candidate_id, j.joborder_id AS matching_skills FROM candidate_skills c CROSS JOIN job_skills j WHERE c.skill_id = j.skill_id and joborder_id =" + str(joborder_id) + " GROUP BY c.candidate_id, j.joborder_id")
cvAndJobId = mycursor.fetchall()
# print(cvAndJobId)
if(len(cvAndJobId)) == 0:
    mycursor.execute("delete from recommended_jobs where jd_id=%s"%joborder_id)
    exit()

mycursor.execute("Select joborder_id, clean_text from clean_joborder where joborder_id = %s"%str(joborder_id))
joborder_text = mycursor.fetchall()
print(joborder_text)
joborder_text = joborder_text[0][1]
candidate_id, _ = zip(*cvAndJobId)

if len(candidate_id) != 1:
    mycursor.execute("SELECT data_item_id,text FROM attachment as a INNER JOIN candidate as c on a.data_item_id=c.candidate_id WHERE a.data_item_type = 100 and a.resume=1 and text = '' and c.is_active=1 and candidate_id in %s GROUP BY a.data_item_id HAVING COUNT(1) = 1 ORDER BY a.date_created DESC"%str(candidate_id))
else:
    mycursor.execute("SELECT data_item_id,text FROM attachment as a INNER JOIN candidate as c on a.data_item_id=c.candidate_id WHERE a.data_item_type = 100 and a.resume=1 and text = '' and c.is_active=1 and candidate_id = %s GROUP BY a.data_item_id HAVING COUNT(1) = 1 ORDER BY a.date_created DESC"%str(candidate_id[0]))

useless_candidates = mycursor.fetchall()

needed_candidates = set(candidate_id) - set(useless_candidates)

if len(needed_candidates) != 1:
    mycursor.execute("select candidate_id, clean_text from clean_resume where candidate_id in %s"%str(tuple(needed_candidates)))
else:
    mycursor.execute("select candidate_id, clean_text from clean_resume where candidate_id = %s"%str(needed_candidates[0]))

myCvTextWithId = mycursor.fetchall()

myCvId, myCvText = zip(*myCvTextWithId)

mycursor.execute("delete from recommended_jobs where jd_id=%s"%joborder_id)
mydb.commit()

insert_sql = "Insert into recommended_jobs (candidate_id, jd_id, score) values (%s, %s, %s)"
result_list = []
j = 0
while j < len(myCvId):
    vectorizer = CountVectorizer(ngram_range= (1, 3), token_pattern= "(?u)\\b\\w+\\b")
    count_array = vectorizer.fit_transform([joborder_text] + [myCvText[j]]).toarray()
    count_array[count_array>6]=6
    score = cosine_similarity([count_array[0]], [count_array[1]])[0][0].astype("float16")
    print(score)
    if(score):
        result_list.append((myCvId[j], score))
        # print((myCvId[j], score))
    j+=1
# print(result_list)
n=0
while n < len(result_list):
    print(result_list[n][0])
    insertval = (result_list[n][0], joborder_id, float(result_list[n][1]))
    mycursor.execute(insert_sql, insertval)
    mydb.commit()
    n+=1

print("Results calculated and inserted")